# runs every tick on a loaded grinding table

# removing illegal items from player inventory
clear @a barrier[item_name='[{"text":""}]']
clear @a minecraft:structure_void[item_name='[{"text":""}]']

# removing illegal items from ground
kill @e[type=item,nbt={Item:{id:"minecraft:barrier",components:{"minecraft:item_name":'""'}}}]
kill @e[type=item,nbt={Item:{id:"minecraft:structure_void",components:{"minecraft:item_name":'""'}}}]

# (bugfix 2) compare armor stand items to hopper slots, if first is the same but the second is different then call function
data remove storage minecraft:hfd_tgt_dupe_bugfix_1 Item
data remove storage minecraft:hfd_tgt_dupe_bugfix_2 Item
tag @s[tag=item_1_matches] remove item_1_matches
tag @s[tag=item_2_matches] remove item_2_matches
tag @s[tag=item_1_doesnt_match] remove item_1_doesnt_match
tag @s[tag=item_2_doesnt_match] remove item_2_doesnt_match
data modify storage minecraft:hfd_tgt_dupe_bugfix_1 Item set from entity @s HandItems[0]
data modify storage minecraft:hfd_tgt_dupe_bugfix_2 Item set from entity @s HandItems[1]
execute if entity @s[tag=the_recipe_is_real] run function hfd-tgt:bugfix_2/macro_1 with storage minecraft:hfd_tgt_dupe_bugfix_1 Item
execute if entity @s[tag=the_recipe_is_real] run function hfd-tgt:bugfix_2/macro_2 with storage minecraft:hfd_tgt_dupe_bugfix_2 Item
execute if entity @s[tag=item_1_matches,tag=item_2_doesnt_match] if items block ~ ~ ~ container.4 * run function hfd-tgt:bugfix_2/fix_bug

# (bugfix) check if wrong item is in slot 1-4, if so then drop it on the ground
execute unless items block ~ ~ ~ container.1 barrier unless items block ~ ~ ~ container.1 air run summon item ~ ~1 ~ {Item:{id:"minecraft:stone"},Tags:["hfd_tgt_tg_missplaced_item"]} 
execute unless items block ~ ~ ~ container.1 barrier unless items block ~ ~ ~ container.1 air run item replace entity @e[type=item,tag=hfd_tgt_tg_missplaced_item,distance=..1] contents from block ~ ~ ~ container.1
execute unless items block ~ ~ ~ container.2 structure_void unless items block ~ ~ ~ container.2 air run summon item ~ ~1 ~ {Item:{id:"minecraft:stone"},Tags:["hfd_tgt_tg_missplaced_item"]} 
execute unless items block ~ ~ ~ container.2 structure_void unless items block ~ ~ ~ container.2 air run item replace entity @e[type=item,tag=hfd_tgt_tg_missplaced_item,distance=..1] contents from block ~ ~ ~ container.2
execute unless items block ~ ~ ~ container.3 barrier unless items block ~ ~ ~ container.3 air run summon item ~ ~1 ~ {Item:{id:"minecraft:stone"},Tags:["hfd_tgt_tg_missplaced_item"]} 
execute unless items block ~ ~ ~ container.3 barrier unless items block ~ ~ ~ container.3 air run item replace entity @e[type=item,tag=hfd_tgt_tg_missplaced_item,distance=..1] contents from block ~ ~ ~ container.3
execute if entity @s[tag=!the_recipe_is_real] unless items block ~ ~ ~ container.4 barrier if items block ~ ~ ~ container.4 * run summon item ~ ~1 ~ {Item:{id:"minecraft:stone"},Tags:["hfd_tgt_tg_missplaced_item"]} 
execute if entity @s[tag=!the_recipe_is_real] unless items block ~ ~ ~ container.4 barrier if items block ~ ~ ~ container.4 * run item replace entity @e[type=item,tag=hfd_tgt_tg_missplaced_item,distance=..1] contents from block ~ ~ ~ container.4

# finish recipes
# this command needs to be here because if it was later the other commands can break this one
execute if entity @s[tag=the_recipe_is_real,tag=!invalid_recipe] unless items block ~ ~ ~ container.4 * run function hfd-tgt:recipe_finish

# armor stand giving himself tag based of criteria
execute if entity @s[tag=!the_recipe_is_real] if items block ~ ~ ~ container.0 * run tag @s add the_recipe_is_real
execute unless items block ~ ~ ~ container.0 * run tag @s remove the_recipe_is_real

# set slot 4 to barrier if he dont got da tag
execute if entity @s[tag=!the_recipe_is_real] unless items block ~ ~ ~ container.4 barrier run item replace block ~ ~ ~ container.4 with minecraft:barrier[hide_tooltip={},item_model="minecraft:air",item_name='[{"text":""}]']

# display da item thats in da table in da item display
execute if entity @s[tag=the_recipe_is_real] run item replace entity @e[type=minecraft:item_display,sort=nearest,limit=1,tag=gt_item_displayer,distance=..1] contents from block ~ ~ ~ container.0
execute if entity @s[tag=!the_recipe_is_real] unless items entity @e[type=minecraft:item_display,sort=nearest,limit=1,tag=gt_item_displayer,distance=..1] contents minecraft:air run item replace entity @e[type=minecraft:item_display,sort=nearest,limit=1,tag=gt_item_displayer,distance=..1] contents with minecraft:air

# recipes
execute if entity @s[tag=the_recipe_is_real] run function #hfd-tgt:gt_recipes

# add and remove invalid_recipe tag if recipe is invalid
execute if entity @s[tag=the_recipe_is_real] if items block ~ ~ ~ container.4 barrier run tag @s add invalid_recipe
tag @s[tag=!the_recipe_is_real] remove invalid_recipe

# destroying da table
execute unless block ~ ~ ~ minecraft:hopper run function hfd-tgt:gt_destroy

# fix hopper if updated
data remove storage hfd_tgt_temp Items
data modify storage hfd_tgt_temp Items set from block ~ ~ ~ Items
execute if block ~ ~ ~ minecraft:hopper[enabled=true] run setblock ~ ~ ~ hopper[enabled=false,facing=down]{CustomName:'[{"text":"Grinding Table"}]'}
data modify block ~ ~ ~ Items set from storage hfd_tgt_temp Items

# placing gui items
# these commands need to be here because if they were somewhere higher the blocked arrow would show up incorrectly
item replace block ~ ~ ~ container.1 with barrier[hide_tooltip={},item_model="minecraft:air",item_name='[{"text":""}]']
item replace block ~ ~ ~ container.2 with minecraft:structure_void[hide_tooltip={},item_model="hfd-tgt:gt_gui_main",item_name='[{"text":""}]']
item replace block ~ ~ ~ container.3 with barrier[hide_tooltip={},item_model="hfd-tgt:gt_gui_icons",item_name='[{"text":""}]']
execute if items block ~ ~ ~ container.0 * if items block ~ ~ ~ container.4 minecraft:barrier run item replace block ~ ~ ~ container.3 with barrier[hide_tooltip={},item_model="hfd-tgt:gt_gui_icons_blocked",item_name='[{"text":""}]']

# (bugfix 2) add items from slots 0 and 4 to armor stand arms for later comparing
item replace entity @s weapon.mainhand from block ~ ~ ~ container.0
item replace entity @s weapon.offhand from block ~ ~ ~ container.4


